; -----------------------------------------------------------------------------
;	SCA main program
; -----------------------------------------------------------------------------

		.include	"sca_info.asm"
		.include	"bgmdriver_h.asm"

		; sca_player.asm Ē`Ă郋[`̐錾
		.globl	player_init
		.globl	player_move
		.globl	shot_init
		.globl	shot_move
		.globl	shot_fire
		.globl	sprite_init
		.globl	sprite_pattern_init
		.globl	sprite_update
		.globl	enemy_init
		.globl	enemy_start
		.globl	enemy_move
		.globl	background_init
		.globl	enemy_shot_move
		.globl	background_scroll
		.globl	check_enemy_clash
		.globl	vsync_init
		.globl	software_timer
		.globl	score_init
		.globl	sca_title
		.globl	background_init_game_screen

		.area	CODE (ABS)
		.org	#0x9000

sca_main::
		call	game_init						; e평
sca_main_loop:
		call	sca_title						; ^Cg
		call	background_init_game_screen		; Q[̔wi
		call	score_init						; _
		ld		hl, #bgm_stage1					; stage1  BGM tJn
		call	bgmdriver_play
		call	game_start						; C[v
		call	bgmdriver_stop
		jr		sca_main_loop

; -----------------------------------------------------------------------------
;	
; -----------------------------------------------------------------------------
game_init:
		; COLOR 15,0,0
		ld		a, #15
		ld		(FORCLR), a
		xor		a
		ld		(BAKCLR), a
		ld		(BDRCLR), a
		; SCREEN 4
		ld		a, (RG1SAV)		; VDP(1) = (VDP(1) AND &HFC) OR 0x02		XvCgTCY 16x16, Q{g喳
		and		#0xFC
		or		#0x02
		ld		(RG1SAV), a
		ld		a, #4			; SCREEN 4
		call	CHGMOD
		; @
		ld		ix, #player_info
		call	player_init
		; @e
		ld		ix, #shot_info0
		call	shot_init
		ld		ix, #shot_info1
		call	shot_init
		ld		ix, #shot_info2
		call	shot_init
		; XvCg
		call	sprite_init
		call	sprite_pattern_init
		call	enemy_init
		; wi
		call	background_init
		; BGM Driver 
		call	bgmdriver_initialize
		; 荞ݏ
		call	vsync_init
		ret

; -----------------------------------------------------------------------------
;	C[v
; -----------------------------------------------------------------------------
game_start:
		xor		a
		ld		(stage_clear_flag), a
game_loop:
		; Q[NAH
		ld		a, (stage_clear_flag)
		or		a
		jp		nz, game_stage_clear
		; ݂̃^C}[lۑĂ
		ld		a, (software_timer)
		ld		(last_timer), a
		; @̈ړ
		ld		ix, #player_info
		call	player_move
		; @e̔ˏ
		ld		ix, #player_info
		ld		iy, #shot_info0
		call	shot_fire
		; @ëړ
		ld		ix, #shot_info0
		call	shot_move
		ld		ix, #shot_info1
		call	shot_move
		ld		ix, #shot_info2
		call	shot_move
		; G̈ړ
		ld		ix, #enemy_info0
		call	enemy_move
		; G̏o
		ld		ix, #player_info
		ld		iy, #enemy_info0
		call	enemy_start
		; Gëړ
		ld		ix, #eshot_info
		call	enemy_shot_move
		; wĩXN[
		call	background_scroll
		; G̓蔻菈
		call	check_enemy_clash
		; XvCg̕\XV
		ld		ix, #player_info
		call	sprite_update
		; ^C}[lω܂őҋ@
		ld		a, (last_timer)
		ld		hl, #software_timer
game_wait_loop:
		cp		(hl)
		jp		nz, game_loop
		jr		game_wait_loop

; -----------------------------------------------------------------------------
;	Xe[WNA
; -----------------------------------------------------------------------------
game_stage_clear:
		; {XjBGM
		ld		hl, #bgm_clear
		call	bgmdriver_play
		; b
game_stage_clear_loop:
		call	bgmdriver_check_playing
		jr		nz, game_stage_clear_loop
		ret

; -----------------------------------------------------------------------------
;	Xe[WNA֑J
; -----------------------------------------------------------------------------
goto_next_stage::
		ld		a, #1
		ld		(stage_clear_flag), a
		ret

; -----------------------------------------------------------------------------
;	[NGA
; -----------------------------------------------------------------------------
last_timer:
		.db		#0

stage_clear_flag:
		.db		#0

; -----------------------------------------------------------------------------
;	@
; -----------------------------------------------------------------------------
player_info::
		.ds		SCA_INFO_SIZE		; 0
		.ds		SCA_INFO_SIZE		; 1
enemy_info0::
		.ds		SCA_INFO_SIZE		; 2
		.ds		SCA_INFO_SIZE		; 3
enemy_info1::
		.ds		SCA_INFO_SIZE		; 4
		.ds		SCA_INFO_SIZE		; 5
enemy_info2::
		.ds		SCA_INFO_SIZE		; 6
		.ds		SCA_INFO_SIZE		; 7
enemy_info3::
		.ds		SCA_INFO_SIZE		; 8
		.ds		SCA_INFO_SIZE		; 9
enemy_info4::
		.ds		SCA_INFO_SIZE		; 10
		.ds		SCA_INFO_SIZE		; 11
enemy_info5::
		.ds		SCA_INFO_SIZE		; 12
		.ds		SCA_INFO_SIZE		; 13
shot_info0::
		.ds		SCA_INFO_SIZE		; 14
shot_info1::
		.ds		SCA_INFO_SIZE		; 15
shot_info2::
		.ds		SCA_INFO_SIZE		; 16
eshot_info::
		.ds		SCA_INFO_SIZE		; 17
		.ds		SCA_INFO_SIZE		; 18
		.ds		SCA_INFO_SIZE		; 19
		.ds		SCA_INFO_SIZE		; 20
		.ds		SCA_INFO_SIZE		; 21
		.ds		SCA_INFO_SIZE		; 22
		.ds		SCA_INFO_SIZE		; 23
		.ds		SCA_INFO_SIZE		; 24
		.ds		SCA_INFO_SIZE		; 25
		.ds		SCA_INFO_SIZE		; 26
		.ds		SCA_INFO_SIZE		; 27
		.ds		SCA_INFO_SIZE		; 28
		.ds		SCA_INFO_SIZE		; 29
		.ds		SCA_INFO_SIZE		; 30
item_info::
		.ds		SCA_INFO_SIZE		; 31

; -----------------------------------------------------------------------------
;	ȃf[^
; -----------------------------------------------------------------------------
bgm_stage1::
		.include	"stage_bgm.asm"
bgm_boss1::
		.include	"boss_bgm.asm"
bgm_clear::
		.include	"clear_bgm.asm"
